/*
 * wath_log.c - wath ѥ⥸塼
 *    Mon, Mar 4 1996 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include "status_code.h"
#include "common.h"
#include "request.h"

/*
 * ɽؿ
 */
static void	WriteErrorLog();
static void	SendErrorMessage();

/*
 * ؿ̾:	WriteAccessLog
 * ǽ:	եؤεϿ()
 * :	׵ȥեξ֤ؤΥݥ
 * :	ʤ
 */
void WriteAccessLog(req, fstatus)
	Request		*req;
	struct stat	*fstatus;
{
  register int	fd;
  char		buf[BUF_SIZE];
  const char	subject[] = "Warning Mail from WATH";

  /* Ƥʤ or 롦ۥȤΥ	*/
  if ((serv.log.access == NULL) || 
      IsEqual(host.fqdn, "localhost") || 
      IsEqual(host.ip_addr, "127.0.0.1")) {
    return;
  }

  /* Fully-Qualified Domain Name ǤΥۥ̾	*/
  if (host.fqdn[0] != EOL) {
    (void)sprintf(buf, "%s [%s] <%s> (%s) \"%s /%s %s\" (%d)\n", Date(NULL), 
		  host.fqdn, req->mailbox, req->user_agent, req->method, 
		  req->url, req->protocol, (int)fstatus->st_size);
  }
  else {	/* IP ɥ쥹ǤΥۥ̾	*/
    (void)sprintf(buf, "%s [%s] <%s> (%s) \"%s /%s %s\" (%d)\n", Date(NULL), 
		  host.ip_addr, req->mailbox, req->user_agent, req->method, 
		  req->url, req->protocol, (int)fstatus->st_size);
  }

  /* 򳫤	*/
  if ((fd = open(serv.log.access, O_WRONLY | O_APPEND | O_CREAT, 0600)) < 0) {
#ifdef	JP_MESG				/* ܸʸ	*/
    (void)sprintf(buf, "%s ե򳫤ȤǤޤ", serv.log.access);
#else					/* Ѹʸ	*/
    (void)sprintf(buf, "Can't open %s .", serv.log.access);
#endif	/* JP_MESG */
    SendMail(subject, buf);
    return;
  }
  (void)write(fd, buf, strlen(buf));	/* ˽񤭹	*/
  (void)close(fd);			/* Ĥ	*/

#ifdef	MORE_LOG
  /* 桼򳫤	*/
  (void)sprintf(buf, "%s\n", req->mailbox);
  if ((fd = open(serv.log.user, O_WRONLY | O_APPEND | O_CREAT, 0600)) < 0) {
#ifdef	JP_MESG				/* ܸʸ	*/
    (void)sprintf(buf, "%s ե򳫤ȤǤޤ", serv.log.user);
#else					/* Ѹʸ	*/
    (void)sprintf(buf, "Can't open %s .", serv.log.user);
#endif	/* JP_MESG */
    SendMail(subject, buf);
    return;
  }
#ifdef	DEBUG
  (void)fprintf(stderr, "UserLog(%s):\t%s", serv.log.user, buf);
#endif	/* DEBUG */
  (void)write(fd, buf, strlen(buf));	/* 桼˽񤭹	*/
  (void)close(fd);			/* 桼Ĥ		*/

  /* ۥȡ򳫤	*/
  if (host.fqdn[0] != EOL) {	/* FQDN ǤΥۥ̾	*/
    (void)sprintf(buf, "%s (%s)\n", host.fqdn, Date(NULL));
  }
  else {	/* IP ɥ쥹ǤΥۥ̾	*/
    (void)sprintf(buf, "%s (%s)\n", host.ip_addr, Date(NULL));
  }

  if ((fd = open(serv.log.host, O_WRONLY | O_APPEND | O_CREAT, 0600)) < 0) {
#ifdef	JP_MESG				/* ܸʸ	*/
    (void)sprintf(buf, "%s ե򳫤ȤǤޤ", serv.log.host);
#else					/* Ѹʸ	*/
    (void)sprintf(buf, "Can't open %s .", serv.log.host);
#endif	/* JP_MESG */
    SendMail(subject, buf);
    return;
  }
#ifdef	DEBUG
  (void)fprintf(stderr, "HostLog(%s):\t%s\n", serv.log.host, buf);
#endif	/* DEBUG */
  (void)write(fd, buf, strlen(buf));	/* ۥȡ˽񤭹	*/
  (void)close(fd);			/* ۥȡĤ	*/

  /* ȡ򳫤	*/
  (void)sprintf(buf, "%s\n", req->user_agent);
  if ((fd = open(serv.log.agent, O_WRONLY | O_APPEND | O_CREAT, 0600)) < 0) {
#ifdef	JP_MESG				/* ܸʸ	*/
    (void)sprintf(buf, "%s ե򳫤ȤǤޤ", serv.log.agent);
#else					/* Ѹʸ	*/
    (void)sprintf(buf, "Can't open %s .", serv.log.agent);
#endif	/* JP_MESG */
    SendMail(subject, buf);
    return;
  }
#ifdef	DEBUG
  (void)fprintf(stderr, "AgentLog(%s):\t%s\n", serv.log.agent, buf);
#endif	/* DEBUG */
  (void)write(fd, buf, strlen(buf));	/* ȡ˽񤭹	*/
  (void)close(fd);			/* ȡĤ	*/

  /* ե롦򳫤	*/
  (void)sprintf(buf, "http://%s:%d/%s\n", serv.name, serv.port, req->url);
  if ((fd = open(serv.log.refer, O_WRONLY | O_APPEND | O_CREAT, 0600)) < 0) {
#ifdef	JP_MESG				/* ܸʸ	*/
    (void)sprintf(buf, "%s ե򳫤ȤǤޤ", serv.log.refer);
#else					/* Ѹʸ	*/
    (void)sprintf(buf, "Can't open %s .", serv.log.refer);
#endif	/* JP_MESG */
    SendMail(subject, buf);
    return;
  }
#ifdef	DEBUG
  (void)fprintf(stderr, "ReferLog(%s):\t%s\n", serv.log.refer, buf);
#endif	/* DEBUG */
  (void)write(fd, buf, strlen(buf));	/* ȥե롦˽񤭹	*/
  (void)close(fd);			/* ȥե롦Ĥ	*/
#endif	/* MORE_LOG */
}

/*
 * ؿ̾:	WriteErrorLog
 * ǽ:	եؤεϿ(顼)
 * :	顼ֹ
 * :	ʤ
 */
static void WriteErrorLog(errno)
	int	errno;
{
  int		fd;
  char		buf[BUF_SIZE];
  const char	subject[] = "Warning Mail from WATH";

  /* 顼Ƥʤ	*/
  if (serv.log.error == NULL) {
    return;
  }

  /* Fully-Qualified Domain Name ǤΥۥ̾	*/
  if (host.fqdn[0] != EOL) {
    (void)sprintf(buf, "%s [%s] %s (%d)\n", Date(NULL), host.fqdn,
		  status_code[errno].type, status_code[errno].code);
  }
  else {	/* IP ɥ쥹ǤΥۥ̾	*/
    (void)sprintf(buf, "%s [%s] %s (%d)\n", Date(NULL), host.ip_addr,
		  status_code[errno].type, status_code[errno].code);
  }

  /* 顼򳫤	*/
  if ((fd = open(serv.log.error, O_WRONLY | O_APPEND | O_CREAT, 0600)) < 0) {
#ifdef	JP_MESG				/* ܸʸ	*/
    (void)sprintf(buf, "%s ե򳫤ȤǤޤ", serv.log.error);
#else					/* Ѹʸ	*/
    (void)sprintf(buf, "Can't open %s .", serv.log.error);
#endif	/* JP_MESG */
    SendMail(subject, buf);
    return;
  }
  (void)write(fd, buf, strlen(buf));	/* 顼˽񤭹	*/
  (void)close(fd);			/* 顼Ĥ		*/
}

/*
 * ؿ̾:	SendErrorMessage
 * ǽ:	顼å
 * :	顼ֹ
 * :	ʤ
 */
#define	ERROR_HEADER	"\r\n<HTML><HEAD><TITLE>Error</TITLE></HEAD><BODY><H1>"
#define	ERROR_FOOTER	"</BODY></HTML>\r\n"

static void SendErrorMessage(errno)
	int	errno;
{
  char	buf[BUF_SIZE];

  (void)sprintf(buf, "%sError %d</H1>%s%s", ERROR_HEADER,
		status_code[errno].code, status_code[errno].mesg, ERROR_FOOTER);
  (void)write(sd, buf, strlen(buf));
}

/*
 * ؿ̾:	ErrorTrap
 * ǽ:	顼(ؿƤ򸫤ʬ)
 * :	顼ֹ
 * :	ʤ
 */
void ErrorTrap(errno)
	int	errno;
{
  SendHttpHeader(errno, NULL, ERROR_MESSAGE_TYPE);
  SendErrorMessage(errno);
  WriteErrorLog(errno);
}
