/*
 * wath_request.c - WATH  HTTP ϥ⥸塼
 *    Mon, Mar 4 1996 by Kouichi ABE (WALL)
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include "status_code.h"
#include "common.h"
#include "request.h"
#include "security.h"
#include "server.h"

/*
 * ޥ
 */
#define	NOT_TEXT_FILE	0
#define	TEXT_FILE	1
#define	MAX_ENTRY	100	/* ǥ쥯ȥ¸ߤե	*/

/*
 * ɽؿ
 */
static void	SendHTMLDocument();
static void	IndexingOfTheDirectory();
static void	SendFileStatus();
static int	SplitContentOfRequest();
static char	*FileMode();
static void	QuickSort();
static void	Swap();
#ifdef	DEBUG
static void	Debug();
#endif	/* DEBUG */	

/*
 * ؿ̾:	SendHttpHeader
 * ǽ:	HTTP/1.0 ˽򤷤إå򥯥饤Ȥ
 * :	ơɡե֤ؤΥݥ󥿡
 *		ƥȡ
 * :	ʤ
 */
#define	CRLF	"\r\n"
void SendHttpHeader(scode, fstatus, ctype)
	int		scode;
	struct stat	*fstatus;
	char		*ctype;
{
  char		buf[BUF_SIZE];
#ifdef	JP_MESG
  char		tmp[BUF_SIZE];
#endif	/* JP_MESG */

  (void)sprintf(buf, "%s %d %s\r\n", PROTOCOL, status_code[scode].code,
		status_code[scode].type);
#ifdef	JP_MESG
  (void)strcpy(tmp, (char *)JapaneseStringConvertTo(buf, JIS));
  (void)write(sd, tmp, strlen(tmp));
#else
  (void)write(sd, buf, strlen(buf));
#endif	/* JP_MESG */
  (void)sprintf(buf, "Date: %s\nServer: %s\n", Date(NULL), SERVER);
  (void)write(sd, buf, strlen(buf));
  (void)sprintf(buf, "Allow: %s\nContent-Type: %s\r\n", METHODS, ctype);
  (void)write(sd, buf, strlen(buf));

  if (fstatus != NULL) {	/* եξ	*/
    (void)sprintf(buf, "Content-Length: %d\nLast-Modified: %s\r\n",
		  (int)fstatus->st_size, Date(&fstatus->st_mtime));
    (void)write(sd, buf, strlen(buf));
  }

  if (scode == UNAUTHORIZED) {	/* 桼ǧڤ׵	*/
    (void)sprintf(buf, "WWW-Authenticate: Basic realm=\"%s\"\r\n", serv.name);
    (void)write(sd, buf, strlen(buf));
  }

  (void)write(sd, CRLF, 2);
}

/*
 * ؿ̾:	TreatRequest
 * ǽ:	HTTP ˤ׵ν
 * :	׵ƤؤΥݥ
 * :	ʤ
 */
void TreatRequest(mesg)
	char	*mesg;
{
  Request	req;
  register char	*filecheck;

#ifdef	DEBUG
  (void)fprintf(stderr,"[%s]\n",mesg);
#endif	/* DEBUG */

  /* ׵åβ(Method, URL, Protocol, ...)	*/
  if (SplitContentOfRequest(mesg, &req) < 3) {
    ErrorTrap(BAD_REQUEST);
    return;
  }

  /* POST ᥽åɻˤ׵ƤΥå	*/
  if (IsEqual(req.method, "POST") && (req.content_length == -1)) {
    ErrorTrap(BAD_REQUEST);
    return;
  }

  /* ǥݡȤƤʤ᥽åɤƥ顼	*/
  if (!IsEqual(req.method, "HEAD") &&
      !IsEqual(req.method, "GET") &&
      !IsEqual(req.method, "POST")) {
    ErrorTrap(NOT_IMPLEMENTED);
    return;
  }

  /* ץȥ뤬 HTTP/1.0 Ǥʤϥ顼	*/
  if (!IsEqual(req.protocol, PROTOCOL)) {
    ErrorTrap(BAD_REQUEST);
    return;
  }

  filecheck = req.url;	/* URL ե̾Υå	*/

#ifdef	DEBUG
  (void)fprintf(stderr, "[%s][%s]\n", req.method, filecheck);
#endif	/* DEBUG */

  while (*filecheck != EOL) {
    if ((filecheck[0] == '.') && (filecheck[1] == '.')) {
      ErrorTrap(NOT_FOUND);
      return;
    }
    else {
      filecheck++;
    }
  }

  /* 桼ǧڤɬפ URL 	*/
  if ((req.auth[0] == EOL) && (IsPrivateURL(req.url) == PRIVATE)) {
    ErrorTrap(UNAUTHORIZED);
    return;
  }

  /* 桼ǧ	*/
  if (req.auth[0] != EOL) {
    if (CheckUser(req.url, req.auth) == FAILURE ) {	/* ǧڼ	*/
      ErrorTrap(SERVICE_UNAVAILABLE);
      return;
    }
  }

  /* URL Υ˽ʬ	*/
  switch (req.url_type) {
    case DOCUMENT:				/* оݤϥե	*/
      if (IsEqual(req.method, "POST")) {
	ErrorTrap(BAD_REQUEST);			/* POST ϥ	*/
      }
      else {
	SendHTMLDocument(&req);			/* ɥȤ	*/
      }
      break;
    case DIRECTORY:				/* оݤϥǥ쥯ȥ	*/
      if (IsEqual(req.method, "GET")) {
	IndexingOfTheDirectory(req.url);	/* ǥ쥯ȥɽ	*/
      }
      else {
	ErrorTrap(BAD_REQUEST);			/* GET ʳϥ	*/
      }
      break;
    case CGI_BIN:				/* оݤ CGI 	*/
      TreatCGI(req.method, req.url);		/* CGI ޥɤν	*/
      break;
    default:
      ErrorTrap(BAD_REQUEST);			/* 嵭ʳϥ	*/
      break;
  }
}

/*
 * ؿ̾:	SendHTMLDocument
 * ǽ:	URL ǻꤵ줿 HTML ʸ
 * :	ꥯȹ¤ΤؤΥݥ
 * :	ʤ
 */
static void SendHTMLDocument(req)
	Request	*req;
{
  int		fd, nbyte;
  char		buf[BUF_SIZE];
  struct stat	status;

  /* URL ǻꤵ줿եΥץ	*/
  if ((fd = open(req->url, O_RDONLY)) < 0) {
    ErrorTrap(NOT_FOUND);
    return;
  }

  /* URL ǻꤵ줿ե롦ơμ	*/
  if (fstat(fd, &status) < 0) {
    ErrorTrap(NOT_FOUND);
    (void)close(fd);
    return;
  }

  /* URL ǻꤵ줿ե뤬̾ե뤫?¾ͤɤ뤫?Υå */
  if (!S_ISREG(status.st_mode) || !(status.st_mode & S_IROTH)) {
    ErrorTrap(NOT_FOUND);
    (void)close(fd);
    return;
  }

#ifdef	DEBUG
  (void)fprintf(stderr, "\nSend\n");
  Debug(req);
#endif	/* DEBUG */

  /* إåž	*/
  SendHttpHeader(OK, &status, ContentType(req->url));

#ifdef	DEBUG
  (void)fprintf(stderr, "\nSend2\n");
  Debug(req);
#endif	/* DEBUG */

  /* Method  HEAD ʳϥ饤Ȥ˻ꤵ줿 URL Ƥž	*/
  if (!IsEqual(req->method, "HEAD")) {
    register int	text = TEXT_FILE;
    if (!IsEqual(ContentType(req->url), "text/html") &&
	!IsEqual(ContentType(req->url), "text/plain")) {
      text = NOT_TEXT_FILE;
    }
    if (serv.jisout && text) {		/* JIS ɤѴ */
      JapaneseTextConvertTo(fd, sd, JIS);
    }
    else {				/* ̵Ѵ	*/
      while ((nbyte = read(fd, buf, BUF_SIZE)) > 0) {
	(void)write(sd, buf, (size_t)nbyte);
      }
    }
  }
  (void)close(fd);			/* ե뵭һҤΥ	*/
    
  WriteAccessLog(req, &status);	/* ˻Ĥ	*/
}

/*
 * ؿ̾:	IndexingOfTheDirectory
 * ǽ:	URL ǻꤵ줿ǥ쥯ȥưŪ HTML ʸˤ
 * :	URL 
 * :	ʤ
 */
static void IndexingOfTheDirectory(url)
	char	*url;
{
  register DIR			*dfd;
  register struct dirent	*dp;
  char				*dir[MAX_ENTRY];
  struct stat			status;
  char				buf[BUF_SIZE], current[BUF_SIZE];
  int				dnum=0, i;

  /* ǥ쥯ȥΥץ	*/
  (void)sprintf(current, "%s/%s", serv.file.real, url);
  if ((dfd = opendir(current)) == NULL) {
    ErrorTrap(NOT_FOUND);
    return;
  }

  /* URL ǻꤵ줿ե롦ơμ	*/
  if (stat(current, &status) < 0) {
    ErrorTrap(NOT_FOUND);
    return;
  }

  /* ǥ쥯ȥΥեɤ߽Ф	*/
  while ((dp = readdir(dfd)) != NULL) {
#if	SYSTEM_V || LINUX || SUNOS4
    if ((dp->d_name[0] == '.') || (dnum > MAX_ENTRY - 1)) {
#else
    if ((dp->d_name[0] == '.') || (dp->d_type == DT_UNKNOWN) ||
    	(dnum > MAX_ENTRY - 1)) {
#endif
      continue;
    }
    if ((dir[dnum] = (char *)malloc(sizeof(dp->d_name) + 1)) == NULL) {
      closedir(dfd);
      ErrorTrap(NOT_FOUND);
      return;
    }
    (void)strcpy(dir[dnum], dp->d_name);
    dnum++;
  }
  QuickSort(dir, 0, dnum-1);	/* ե	*/

  /* إåž	*/
  SendHttpHeader(OK, &status, "text/html");

  (void)sprintf(buf, "<html><head><title>Index of %s</title></head><body>\n",
		url);
  (void)write(sd, buf, strlen(buf));
  (void)sprintf(buf, "<h1>Index of %s</h1><ul>\n", url);
  (void)write(sd, buf, strlen(buf));

  /* ǥ쥯ȥƤž	*/
  for (i=0; i<dnum; i++) {
    SendFileStatus(current, dir[i]);
    free(dir[i]);	/* ΰβ	*/
  }

  (void)sprintf(buf, "</ul></body></html>\r\n");
  (void)write(sd, buf, strlen(buf));

  (void)closedir(dfd);	/* ǥ쥯ȥΥ	*/
}

/*
 * ؿ̾:	SendFileStatus
 * ǽ:	եξ
 * :	ǥ쥯ȥ̾ȥե̾
 * :	ʤ
 */
static void SendFileStatus(dir, file)
	char	*dir, *file;
{
  struct stat	status;
  char		path[PATH_LEN], buf[BUF_SIZE];

  (void)sprintf(path, "%s/%s", dir, file);

  if (stat(path, &status) < 0) {	/* եξ	*/
    (void)sprintf(buf, "<li><a href=\"%s\">%s</a><p>\n", file, file);
    (void)write(sd, buf, strlen(buf));
    return;
  }

  if (S_ISDIR(status.st_mode) != 0) {		/* ǥ쥯ȥ		*/
    (void)sprintf(buf, "<li>%s %s <a href=\"%s/\">%s</a> (%d Byte)<p>\n",
		  FileMode(status.st_mode), Date(&status.st_mtime), file, file,
		  (int)status.st_size);
  }
  else if (S_ISLNK(status.st_mode) != 0) {	/* ܥå	*/
    (void)sprintf(buf, "<li>%s %s <a href=\"%s@\">%s</a> (%d Byte)<p>\n",
		  FileMode(status.st_mode), Date(&status.st_mtime), file, file,
		  (int)status.st_size);
  }
  else {					/* ̤Υե	*/
    (void)sprintf(buf, "<li>%s %s <a href=\"%s\">%s</a> (%d Byte)<p>\n",
		  FileMode(status.st_mode), Date(&status.st_mtime), file, file,
		  (int)status.st_size);
  }
  (void)write(sd, buf, strlen(buf));
}

/*
 * ؿ̾:	FileMode
 * ǽ:	եΥ⡼ɤ
 * :	ե롦⡼ɹ¤ΤؤΥݥ
 * :	եΥ⡼
 */
static char *FileMode(m)
	mode_t	m;
{
  static char	mode[11];
  char		*p = mode;

  (void)strcpy(mode, "----------");
  switch (m & S_IFMT) {	/* եηη	*/
    case S_IFDIR:	/* ǥ쥯ȥ		*/
      *p = 'd';
      break;
    case S_IFCHR:	/* 饯üե	*/
      *p = 'c';
      break;
    case S_IFBLK:	/* ֥åüե	*/
      *p = 'b';
      break;
    case S_IFREG:	/* ̾ե		*/
      *p = '-';
      break;
    case S_IFLNK:	/* ܥå	*/
      *p = 'l';
      break;
    case S_IFSOCK:	/* å		*/
      *p = 's';
      break;
    case S_IFIFO:	/* ѥ		*/
      *p = 'p';
      break;
  }

  *++p = (S_IREAD  & m	      ? 'r' : '-');	/* ͭɤ߽Фǽ	*/
  *++p = (S_IWRITE & m	      ? 'w' : '-');	/* ͭԽ񤭹߲ǽ	*/
  *++p = (S_IEXEC  & m	      ? 'x' : '-');	/* ͭԼ¹Բǽ	*/
  *++p = (S_IREAD  & (m << 3) ? 'r' : '-');	/* 롼ɤ߽Фǽ	*/
  *++p = (S_IWRITE & (m	<< 3) ? 'w' : '-');	/* 롼׽񤭹߲ǽ	*/
  *++p = (S_IEXEC  & (m << 3) ? 'x' : '-');	/* 롼׼¹Բǽ	*/
  *++p = (S_IREAD  & (m << 6) ? 'r' : '-');	/* ¾ɤ߽Фǽ	*/
  *++p = (S_IWRITE & (m	<< 6) ? 'w' : '-');	/* ¾ͽ񤭹߲ǽ	*/
  *++p = (S_IEXEC  & (m << 6) ? 'x' : '-');	/* ¾ͼ¹Բǽ		*/

  if (S_ISUID & m) {	/* suid ӥåȤΩäƤ	*/
    mode[3] = (mode[3] == '-' ? 'S' : 's');
  }
  if (S_ISGID & m) {	/* sgid ӥåȤΩäƤ	*/
    mode[6] = (mode[6] == '-' ? 'S' : 's');
  }
  if (S_ISVTX & m) {	/* sticky ӥåȤΩäƤ	*/
    mode[3] = (mode[9] == '-' ? 'T' : 't');
  }

  return(mode);
}

/*
 * ؿ̾:	SplitContentOfRequest
 * ǽ:	HTTP ˤ׵Ƥʬ
 * :	׵ƤؤΥݥ󥿡ꥯȹ¤ΤؤΥݥ
 * :	ʬ䤵줿
 */
#define	TOKEN		"\r\n\t "
#define	TOKEN2		"\r\n:"
#define	TOKEN3		"\r\n\t: "
#define	MAX_ARGS	2
#define	MAX_ARGS2	3

static int SplitContentOfRequest(mesg, req)
	char	*mesg;
	Request	*req;
{
  char	*p;			/* mesg ʸ򼨤ݥ	*/
  int	c;			/* ʬ䤷򥫥			*/
  char	*args[MAX_ARGS];
  char	buf[BUF_SIZE];

  c = 0;

  /* User-Agent 	*/
  (void)strcpy(req->user_agent, "Unknown User-Agent");
  if (StrIndex(mesg, "User-Agent", buf) == SUCCESS) {
    if (Split(buf, args, TOKEN2, MAX_ARGS) == MAX_ARGS) {
      (void)strcpy(req->user_agent, args[1]);
      c++;
    }
  }

  /* From 	*/
  (void)strcpy(req->mailbox, "Unknown E-Mail");
  if (StrIndex(mesg, "From", buf) == SUCCESS) {
    if (Split(buf, args, TOKEN3, MAX_ARGS) == MAX_ARGS) {
      (void)strcpy(req->mailbox, args[1]);
      c++;
    }
  }

  /* Authorization 	*/
  req->auth[0] = EOL;
  if (StrIndex(mesg, "Authorization", buf) == SUCCESS) {
    if (Split(buf, args, TOKEN, MAX_ARGS2) == MAX_ARGS2) {
      (void)strcpy(req->auth, args[2]);
      c++;
    }
  }

  /* Accept 	*/
  (void)strcpy(req->accept, "*/*");
  if (StrIndex(mesg, "Accept", buf) == SUCCESS) {
    if (Split(buf, args, TOKEN2, MAX_ARGS) == MAX_ARGS) {
      (void)strcpy(req->accept, args[1]);
      c++;
    }
  }

  /* Referer 	*/
  req->referer[0] = EOL;
  if (StrIndex(mesg, "Referer", buf) == SUCCESS) {
    if (Split(buf, args, TOKEN, MAX_ARGS) == MAX_ARGS) {
      (void)strcpy(req->referer, args[1]);
      c++;
    }
  }

  /* Forwarded 	*/
  req->forwarded[0] = EOL;
  if (StrIndex(mesg, "Forwarded", buf) == SUCCESS) {
    if (Split(buf, args, TOKEN2, MAX_ARGS) == MAX_ARGS) {
      (void)strcpy(req->forwarded, args[1]);
      c++;
    }
  }

  /* Content-Type (POST ᥽åɤλ)	*/
  req->content_type[0] = EOL;
  if ((StrIndex(mesg, "Content-Type", buf) == SUCCESS) ||
      (StrIndex(mesg, "Content-type", buf) == SUCCESS)) {
    if (Split(buf, args, TOKEN2, MAX_ARGS) == MAX_ARGS) {
      (void)strcpy(req->content_type, args[1]);
      c++;
    }
  }

  /* Content-Length (POST ᥽åɤλ)	*/
  req->content_length = -1;
  if ((StrIndex(mesg, "Content-Length", buf) == SUCCESS) ||
      (StrIndex(mesg, "Content-length", buf) == SUCCESS)) {
    if (Split(buf, args, TOKEN2, MAX_ARGS) == MAX_ARGS) {
      req->content_length = atoi(args[1]);
      c++;
    }
  }

  /* ꥯȡեɤ	*/
  if ((p = (char *)strtok(mesg, TOKEN)) != NULL) {	/* ᥽å	*/
    (void)strcpy(req->method, p);
    c++;
    if ((p = (char *)strtok(NULL, TOKEN)) != NULL) {	/* URL		*/
      req->url_type = DOCUMENT;		/* ǥեȤϥɥ	*/
      if (IsNEqual(p, serv.cgi.virtual, strlen(serv.cgi.virtual))) {
        (void)strcpy(req->url, p);
	req->url_type = CGI_BIN;	/* CGI ޥɤ		*/
      }
      else if (p[0] == '/') {		/* Ƭ '/' 		*/
	(void)strcpy(req->url, p+1);
      }
      else {
        (void)strcpy(req->url, p);
      }

      /* Welcome Page CGI ǽΥå	*/
      if ((strlen(req->url) == 0) || IsEqual(req->url, DEFAULT_INDEX)) {
	if (!IsEqual(serv.welcome, "NOUSE")) {
	  (void)strcpy(req->url, serv.welcome);
	  req->url_type = CGI_BIN;	/* CGI ޥɤȤƼ¹	*/
	}
      }

      /* URL  '/' ǽν	*/
      if ((strlen(req->url) == 0) || (req->url[strlen(req->url)-1] == '/')) {
        (void)sprintf(buf, "%s%s", req->url, DEFAULT_INDEX);
	if (access(buf, F_OK) == 0) {		/* ̤Υե	*/
	  (void)strcpy(req->url, buf);
	}
	else {					/* ǥ쥯ȥ		*/
	  req->url[strlen(req->url)-1] = EOL;
	  if (strlen(req->url) == 0) {
	    (void)strcpy(req->url, "/");
	  }
	  req->url_type = DIRECTORY;	/* ǥ쥯ȥɽ	*/
	}
      }
      c++;

      if ((p = (char *)strtok(NULL, TOKEN)) != NULL) {	/* ץȥ	*/
	(void)strcpy(req->protocol, p);
	c++;
	while ((p = (char *)strtok(NULL, TOKEN)) != NULL) {
	  c++;
	}
      }
    }
  }
  return(c);
}

/*
 * ؿ̾:	QuickSort
 * ǽ:	ʸ򾺽
 * :	ʸ󡢺ڤ͡ڤ
 * :	ʤ
 */
static void QuickSort(s, left, right)
	char	*s[];
	int	left, right;
{
  int	i, last;

  if (left >= right) {
    return;
  }

  Swap(s, left, (left + right)/2 );
  last = left;

  for (i=left+1; i<=right; i++) {
    if (strcmp(s[i], s[left]) < 0) {
      Swap(s, ++last, i);
    }
  }

  Swap(s, left, last);
  QuickSort(s, left, last-1);
  QuickSort(s, last+1, right);
}

/*
 * ؿ̾:	Swap
 * ǽ:	ʸθ
 * :	ʸ󡢸򴹾(1)򴹾(2)
 * :	ʤ
 */
static void Swap(s, i, j)
	char	*s[];
	int	i,j;
{
  char	*t;

  t    = s[i];
  s[i] = s[j];
  s[j] = t;
}

/*
 * ؿ̾:	Debug
 * ǽ:	ꥯȹ¤Τͤɽ
 * :	ꥯȹ¤
 * :	ʤ
 */
static void Debug(req)
	Request	*req;
{
  (void)fprintf(stderr,"Method:            [%s]\n",req->method);
  (void)fprintf(stderr,"URL:               [%s]\n",req->url);
  (void)fprintf(stderr,"Protocol:          [%s]\n",req->protocol);
  (void)fprintf(stderr,"URL type:          [%d]\n",req->url_type);
  (void)fprintf(stderr,"User Agent:        [%s]\n",req->user_agent);
  (void)fprintf(stderr,"E-Mail:            [%s]\n",req->mailbox);
  (void)fprintf(stderr,"Auth:              [%s]\n",req->auth);
  (void)fprintf(stderr,"Accept:            [%s]\n",req->accept);
  (void)fprintf(stderr,"Forwarded:         [%s]\n",req->forwarded);
  (void)fprintf(stderr,"Referer:           [%s]\n",req->referer);
  (void)fprintf(stderr,"Content-Type:      [%s]\n",req->content_type);
  (void)fprintf(stderr,"Content-Length:    [%d]\n",req->content_length);
}

