/*
 * wath_security.c - WATH ѥƥ⥸塼
 *    Sat, Jul 6 1996 by Kouichi ABE (WALL)
 */

/*
 * ץȥ:
 *   [Server]
 *	WWW-Authenticate: Basic realm="etnwalrus.yz.yamagata-u.ac.jp"
 *
 *   [Client]
 *	Authorization: Basic QWxhZGRpbjpvcGVuIHNlc2FtZQ==
 *			     Aladdin:open sesame
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#ifdef	SYSTEM_V
#include <signal.h>
#endif
#ifdef	__FreeBSD__
#include <des.h>
#endif
#include "common.h"
#include "security.h"

/*
 * ޥ
 */
#define	USERNAME_SIZE	9		/* 桼̾Υ	     */
#define	PASSWORD_SIZE	14		/* ѥΥ	     */
#define	SALT_SIZE	3		/* ѥɤ̣դʸ󥵥  */
#define	PRIVATE_FILE	CONFDIR ## "/private.passwd" /* ե */

#define	ENTRY_USER	10	/* 1ǥ쥯ȥǥǽʺ桼 */
#define	ENTRY_BUF	ENTRY_USER * 10	/* ENTRY_USER ѥХåե     */
#define	DIR_LEN		20		/* ǥ쥯ȥ̾Ĺ		     */
#define	MAX_DIR		10		/* ǽʺǥ쥯ȥ  */

#ifdef	BUF_SIZE
#undef	BUF_SIZE
#define	BUF_SIZE	80		/* ѥХåե	*/
#endif

/*
 * ¤Τ
 */
typedef struct {	/* 桼ǧѹ¤	*/
  char	username[USERNAME_SIZE];
  char	password[PASSWORD_SIZE];
} Authorization;

typedef struct {	/*  URL ơ֥빽¤	*/
  char	dirname[DIR_LEN];
  char	users[ENTRY_BUF];
} PrivateURLTable;

/*
 * ɽѿ
 */
static PrivateURLTable	pri_url_tbl[MAX_DIR];
static int		pri_url_num;
static char decode_table[] = {	/* base64 Ѵơ֥	*/
  -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
  -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,-1,
  -1,-1,-1,-1, -1,-1,-1,-1, -1,-1,-1,62, -1,-1,-1,63,
  52,53,54,55, 56,57,58,59, 60,61,-1,-1, -1,-1,-1,-1,
  -1, 0, 1, 2,  3, 4, 5, 6,  7, 8, 9,10, 11,12,13,14,
  15,16,17,18, 19,20,21,22, 23,24,25,-1, -1,-1,-1,-1,
  -1,26,27,28, 29,30,31,32, 33,34,35,36, 37,38,39,40,
  41,42,43,44, 45,46,47,48, 49,50,51,-1, -1,-1,-1,-1
};

/*
 * ɽؿ
 */
static int	GetAccessEntry();
static int	Base64Decode();
static char	char64();

/*
 * ؿ̾:	GetAccessEntry
 * ǽ:	桼Υȥꤹ
 * :	(SUCCESS:1) or (FAILURE:0)
 */
static int GetAccessEntry(ac, username)
	Authorization	*ac;
	char		*username;
{
  register FILE	*fp;
  char		buf[BUF_SIZE], *p;

  /* եΥץ	*/
  if ((fp = fopen(PRIVATE_FILE, "r")) == NULL) {
    return(FAILURE);
  }

  /* եθ	*/
  while (fgets(buf, BUF_SIZE, fp) != NULL) {
    if ((p = (char *)strtok(buf, ":")) != NULL) {
      if (IsEqual(username, p)) {			/* 桼ȯ	*/
	(void)strcpy(ac->username, p);
	if ((p = (char *)strtok(NULL, "\n")) != NULL) {
	  (void)strcpy(ac->password, p);	
	}
	else {
	  (void)strcpy(ac->password, (char)NULL);
	}
	(void)fclose(fp);
	return(SUCCESS);
      }
    }
  }
  (void)fclose(fp);
  return(FAILURE);
}

/*
 * ؿ̾:	CheckUser
 * ǽ:	桼ǽĴ٤(桼̾ȥѥɤ)
 * :	(SUCCESS:1) or Ե(FAILURE:0)
 */
int CheckUser(url, auth)
	char	*url, *auth;
{
  Authorization	ac;
  int		i;
  char		buf[BUF_SIZE], *p;
  char		username[USERNAME_SIZE], key[PASSWORD_SIZE];
  char		password[PASSWORD_SIZE], salt[SALT_SIZE];

  /* Base64 󥳡ɤ줿桼ȥǥɤ	*/
  Base64Decode(auth, buf);

  /* ǥɤ줿ʸ桼̾ȥѥɤʬ	*/
  if ((p = (char *)strtok(buf, ":")) != NULL) {
    (void)strcpy(username, p);
    if ((p = (char *)strtok(NULL, "\r\n")) != NULL) {
      (void)strcpy(key, p);
    }
    else {
      return(FAILURE);
    }
  }
  else {
    return(FAILURE);
  }

  /* 桼ȥꤵƤ뤫Ĵ٤	*/
  for (i=0; i<pri_url_num; i++) {
    if ((strstr(url, pri_url_tbl[i].dirname) != NULL) &&	/* Found !  */
	(strstr(pri_url_tbl[i].users, username) == NULL)) {	/* No entry */
      return(FAILURE);	/* ĤƤʤ	*/
    }
  }
  
  /* 桼Υȥ	*/
  if (GetAccessEntry(&ac, username) == FAILURE) {
    return(FAILURE);
  }

  /* ѥɤα̣Ūʸʬ	*/
  (void)strncpy(salt, ac.password, 2);
  (void)strcpy(password, (char *)crypt(key, salt));

  /* ѥɤΥå	*/
  if (IsEqual(password, ac.password)) {
    return(SUCCESS);
  }
  else {
    return(FAILURE);
  }
}

/*
 * ؿ̾:	IsPrivateURL
 * ǽ:	URL Ĵ٤
 * :	(PUBLIC:1) or (PRIVATE:0)
 */
int IsPrivateURL(url)
	char	*url;
{
  int	i;

  /* ꤵ줿 URL 椵Ƥ뤫å	*/
  for (i=0; i<pri_url_num; i++) {
    if (IsEqual(pri_url_tbl[0].dirname, "ALL") ||
	(strstr(url, pri_url_tbl[i].dirname) != NULL)) {
      return(PRIVATE);			/*  URL		*/
    }
  }

  return(PUBLIC);			/*  URL		*/
}

/*
 * ؿ̾:	InitPrivateURLList
 * ǽ:	դ URL ǥ쥯ȥΥꥹȤν
 * :	ʤ
 */
#define	LINE_SIZE	DIR_LEN + ENTRY_BUF
void InitPrivateURLList(void)
{
  register FILE	*fp;
  char		buf[LINE_SIZE], *p;
#ifdef	DEBUG
  int		i;
#endif	/* DEBUG */

#ifdef SYSTEM_V
  signal(SIGHUP, SIG_IGN);
#endif

  /* 桼եΥץ	*/
  if ((fp = fopen(serv.private, "r")) == NULL) {
    return;
  }

  /*  URL ơ֥κ 	*/
  pri_url_num = 0;
  while (fgets(buf, LINE_SIZE, fp) != NULL) {
    if (SkipLine(buf)) {		/* ȹԤʤɤΥå	*/
      continue;
    }
    if ((p = (char *)strtok(buf, ":")) != NULL) {
      (void)strcpy(pri_url_tbl[pri_url_num].dirname, p);
      if ((p = (char *)strtok(NULL, "\n")) != NULL) {
	(void)strcpy(pri_url_tbl[pri_url_num++].users, p);
      }
      else {
	(void)strcpy(pri_url_tbl[pri_url_num++].users, (char)NULL);
      }
    }
    else {	/* ͽ̹ʸؤλŪн	*/
      buf[strlen(buf)-1] = EOL;
      (void)strcpy(pri_url_tbl[pri_url_num].dirname, buf);
      (void)strcpy(pri_url_tbl[pri_url_num++].users, (char)NULL);
    }
  }

#ifdef	DEBUG
  for (i=0; i<pri_url_num; i++) {
    (void)fprintf(stderr, "DIR[%s]\n", pri_url_tbl[i].dirname);
    (void)fprintf(stderr, "USERS[%s]\n", pri_url_tbl[i].users);
  }
#endif	/* DEBUG */

  (void)fclose(fp);			/* եΥ	*/
#ifdef SYSTEM_V
  signal(SIGHUP, ReConfiguration);
#endif
}

/*
 * ؿ̾:	Base64Decode
 * ǽ:	Base64 󥳡ɤ줿ʸΥǥ
 * :	(1) or (0)
 */
static int Base64Decode(s, decoded)
	char		*s;
	unsigned char	*decoded;
{
  int		i,j,state;
  unsigned char	c,c0,c1,c2;
  char		char64_c;

  i = j = state = c0 = c1 = c2 = 0;			/* ѿν	*/

  /* ʸü椫 '=' 椬ޤǥ롼	*/
  while ((s[i] != EOL) && (s[i] != '=')) {
    char64_c = char64(s[i]);			/* ʸɤ߹	*/
    i++;
    if (char64_c == -1) {			/* ǥɼ		*/
      decoded[j] = EOL;				/* ʸüղ	*/
      return(FAILURE);
    }
    c = (unsigned char)char64_c;
    switch (state) {				/* 		*/
      case 0:
	c0    = c << 2;				/* ˣӥåȡե	*/
	state = 1;				/* ֣		*/
	break;
      case 1:
	decoded[j] = c >> 4 | c0;		/* ǥɤʸ	*/
	c1	   = c << 4;			/* ˣӥåȡե	*/
	state	   = 2;				/* ֣		*/
	j++;
	break;
      case 2:
	decoded[j] = c >> 2 | c1;		/* ǥɤʸ	*/
	c2	   = c << 6;			/* ˣӥåȡե	*/
	state	   = 3;				/* ֣		*/
	j++;
	break;
      case 3:
	decoded[j] = c | c2;			/* ǥɤʸ	*/
	state	   = 0;				/* ֣		*/
	j++;
	break;
      default:
	break;
    }
  }

  switch (state) {		/* ֣ޤʤǽλν	*/
    case 1:				/* ֣ǽλ		*/
      decoded[j++] = c0;
      break;
    case 2:				/* ֣ǽλ		*/
      decoded[j++] = c1;
      break;
    case 3:				/* ֣ǽλ		*/
      decoded[j++] = c2;
      break;
    default:
      break;
  }
  decoded[j] = EOL;			/* ʸüդ	*/

  return(SUCCESS);			/* ǥ			*/
}

/*
 * ؿ̾:	char64
 * ǽ:	base64 Υǥɽ֤ͤ
 * :	base64 Υǥɽ
 */
static char char64(c)
	int	c;
{
  if ((c < 0) || (c > 127)) {
    return(-1);
  }
  else {
    return(decode_table[c]);
  }
}
